

#include <QApplication>
#include <QMainWindow>
#include <QCompleter>
#include <QFileInfo>
#include <QInputDialog>
#include <QMessageBox>
#include <QHBoxLayout>
#include <QLabel>
#include <QPushButton>
#include <QTextEdit>
#include <QTextBrowser>

#include <iostream>

#include <boost/format.hpp>

using namespace std;
using boost::format;

int
main(int argc,char **argv)
{
  printf("%d %f %g\n",5,6,7);
  format fmt("%d %f %g\n");
  fmt % 5.1 % 6.2 % 7.3;
  cout << fmt;


  QApplication app(argc,argv);

  // re-usables
  QHBoxLayout *hb;
  QLabel *label;
  QFrame *ww;
  QLineEdit *lineedit;
  QPushButton *button;
  QPalette bgpal,pal2;
  bgpal.setColor(QPalette::Background,QColor(255,255,210));
  pal2.setColor(QPalette::Background,QColor(255,255,255));

  // create main window
  QMainWindow *mw=new QMainWindow();
  mw->resize(600,600);
  mw->show();

  // make a widget, make it the central widget in mw, and give it a vertical layout
  QWidget *ff=new QWidget();
  ff->setAutoFillBackground( true );
  ff->setPalette(pal2);
  mw->setCentralWidget(ff);
  QVBoxLayout *vv=new QVBoxLayout;
  vv->setSpacing(2);
  vv->setMargin(4);
  vv->setAlignment(Qt::AlignTop);
  ff->setLayout(vv);

  QTextEdit *te=new QTextEdit;
  te->setHtml("This is a test.\n\nI <a href=\"foo\"> like</a> it.");
  te->setReadOnly(0);
  vv->addWidget(te);

  QTextEdit *tb=new QTextBrowser;
  tb->setHtml("This is a test.\n\nI <a href=\"foo\"> like</a> it.");
  tb->setReadOnly(0);
  vv->addWidget(tb);


  app.exec();
  exit(0);  
}
